diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java
index 4bb459ef5..1d954c3a1 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/chunk/provider/ChunkProviderSeedViewer.java
@@ -8,249 +8,191 @@ import net.minecraft.core.world.chunk.EmptyChunk;
 import net.minecraft.core.world.chunk.IChunkLoader;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.generate.chunk.ChunkGenerator;
+import net.minecraft.core.world.pos.ChunkPos;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.util.Arrays;
 
 public class ChunkProviderSeedViewer
-    implements IChunkProvider
-{
+    implements IChunkProvider {
     public static final int CHUNK_RADIUS = 64; // Radius should *always* be a power of 2!
     public static final int CHUNK_MASK = CHUNK_RADIUS * 2 - 1;
 
     private static final Logger LOGGER = LogUtils.getLogger();
-    private final Chunk blankChunk;
-    public ChunkGenerator chunkGenerator;
-    private final IChunkLoader chunkLoader;
+    private final @NotNull Chunk blankChunk;
+    public @Nullable ChunkGenerator chunkGenerator;
+    private final @Nullable IChunkLoader chunkLoader;
     private final Chunk[] chunks;
-    private final World worldObj;
-    int lastQueriedChunkXPos;
-    int lastQueriedChunkZPos;
-    private Chunk lastQueriedChunk;
-    private int curChunkX;
-    private int curChunkY;
+    private final @NotNull World world;
+    private @NotNull ChunkPos lastQueriedChunkPos = new ChunkPos(Integer.MIN_VALUE, Integer.MIN_VALUE);
+    private @Nullable Chunk lastQueriedChunk;
+    private @NotNull ChunkPos curChunkPos = new ChunkPos(0, 0);
 
 
-    public ChunkProviderSeedViewer(World world, IChunkLoader ichunkloader, ChunkGenerator chunkGenerator)
-    {
-        chunks = new Chunk[CHUNK_RADIUS * 2 * CHUNK_RADIUS * 2];
-        lastQueriedChunkXPos = Integer.MIN_VALUE;
-        lastQueriedChunkZPos = Integer.MIN_VALUE;
-        blankChunk = new EmptyChunk(world, 0, 0);
-        worldObj = world;
-        chunkLoader = ichunkloader;
+    public ChunkProviderSeedViewer(@NotNull World world, @Nullable IChunkLoader ichunkloader, @Nullable ChunkGenerator chunkGenerator) {
+        this.chunks = new Chunk[CHUNK_RADIUS * 2 * CHUNK_RADIUS * 2];
+        this.blankChunk = new EmptyChunk(world, new ChunkPos(0, 0));
+        this.world = world;
+        this.chunkLoader = ichunkloader;
         this.chunkGenerator = chunkGenerator;
 
     }
 
     @Override
-    public void setCurrentChunkOver(int chunkX, int chunkZ)
-    {
-        curChunkX = chunkX;
-        curChunkY = chunkZ;
+    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
+        this.curChunkPos = new ChunkPos(chunkPos);
     }
 
-    public boolean canChunkExist(int chunkX, int chunkZ)
-    {
-        byte byte0 = CHUNK_RADIUS - 1;
-        return chunkX >= curChunkX - byte0 && chunkZ >= curChunkY - byte0 && chunkX <= curChunkX + byte0 && chunkZ <= curChunkY + byte0;
+    public boolean canChunkExist(@NotNull ChunkPos chunkPos) {
+        byte r = CHUNK_RADIUS - 1;
+        return chunkPos.x >= this.curChunkPos.x - r && chunkPos.z >= this.curChunkPos.z - r && chunkPos.x <= this.curChunkPos.x + r && chunkPos.z <= this.curChunkPos.z + r;
     }
 
     @Override
-    public void regenerateChunk(int chunkX, int chunkZ)
-    {
-        int k = chunkX & CHUNK_MASK;
-        int l = chunkZ & CHUNK_MASK;
-        int i1 = k + l * CHUNK_RADIUS * 2;
+    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
+        int cx = chunkPos.x & CHUNK_MASK;
+        int cz = chunkPos.z & CHUNK_MASK;
+        int index = cx + cz * CHUNK_RADIUS * 2;
         Chunk newChunk;
-        if (chunkGenerator != null)
-        {
-            newChunk = chunkGenerator.generate(chunkX, chunkZ);
+        if (this.chunkGenerator != null) {
+            newChunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
             newChunk.fixMissingBlocks();
-        }
-        else
-        {
+        } else {
             return;
         }
-        chunks[i1] = newChunk;
-        if(!chunks[i1].isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX + 1, chunkZ))
-        {
-            populate(this, chunkX, chunkZ);
+        this.chunks[index] = newChunk;
+        if (!this.chunks[index].isTerrainPopulated && isChunkLoaded(chunkPos.add(1, 1)) && isChunkLoaded(chunkPos.add(0, 1)) && isChunkLoaded(chunkPos.add(1, 0))) {
+            populate(chunkPos);
         }
-        if(isChunkLoaded(chunkX - 1, chunkZ) && !provideChunk(chunkX - 1, chunkZ).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX - 1, chunkZ))
-        {
-            populate(this, chunkX - 1, chunkZ);
+        if (isChunkLoaded(chunkPos.add(-1, 0)) && !provideChunk(chunkPos.add(-1, 0), true).isTerrainPopulated && isChunkLoaded(chunkPos.add(-1, 1)) && isChunkLoaded(chunkPos.add(0, 1)) && isChunkLoaded(chunkPos.add(-1, 0))) {
+            populate(chunkPos.add(-1, 0));
         }
-        if(isChunkLoaded(chunkX, chunkZ - 1) && !provideChunk(chunkX, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX + 1, chunkZ))
-        {
-            populate(this, chunkX, chunkZ - 1);
+        if (isChunkLoaded(chunkPos.add(0, -1)) && !provideChunk(chunkPos.add(0, -1), true).isTerrainPopulated && isChunkLoaded(chunkPos.add(1, -1)) && isChunkLoaded(chunkPos.add(0, -1)) && isChunkLoaded(chunkPos.add(1, 0))) {
+            populate(chunkPos.add(0, -1));
         }
-        if(isChunkLoaded(chunkX - 1, chunkZ - 1) && !provideChunk(chunkX - 1, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX - 1, chunkZ))
-        {
-            populate(this, chunkX - 1, chunkZ - 1);
+        if (isChunkLoaded(chunkPos.add(-1, -1)) && !provideChunk(chunkPos.add(-1, -1), true).isTerrainPopulated && isChunkLoaded(chunkPos.add(-1, -1)) && isChunkLoaded(chunkPos.add(0, -1)) && isChunkLoaded(chunkPos.add(-1, 0))) {
+            populate(chunkPos.add(-1, -1));
         }
     }
 
     @Override
-    public boolean isChunkLoaded(int chunkX, int chunkZ)
-    {
-        if(!canChunkExist(chunkX, chunkZ))
-        {
+    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
+        if (!canChunkExist(chunkPos)) {
             return false;
         }
-        if(chunkX == lastQueriedChunkXPos && chunkZ == lastQueriedChunkZPos && lastQueriedChunk != null)
-        {
+        if (chunkPos.equals(this.lastQueriedChunkPos) && this.lastQueriedChunk != null) {
             return true;
-        } else
-        {
-            int k = chunkX & CHUNK_MASK;
-            int l = chunkZ & CHUNK_MASK;
+        } else {
+            int k = chunkPos.x & CHUNK_MASK;
+            int l = chunkPos.z & CHUNK_MASK;
             int chunkIndex = k + l * CHUNK_RADIUS * 2;
-            return chunks[chunkIndex] == blankChunk || (chunks[chunkIndex] != null && chunks[chunkIndex].isAtLocation(chunkX, chunkZ));
+            return this.chunks[chunkIndex] == this.blankChunk || (this.chunks[chunkIndex] != null && this.chunks[chunkIndex].isAtLocation(chunkPos));
         }
     }
 
     @Override
-    public Chunk prepareChunk(int chunkX, int chunkZ)
-    {
-        return provideChunk(chunkX, chunkZ);
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        return provideChunk(chunkPos, true);
     }
 
     @Override
-    public Chunk provideChunk(int chunkX, int chunkZ)
-    {
-        if(chunkX == lastQueriedChunkXPos && chunkZ == lastQueriedChunkZPos && lastQueriedChunk != null)
-        {
-            return lastQueriedChunk;
+    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        if (chunkPos.equals(this.lastQueriedChunkPos) && this.lastQueriedChunk != null) {
+            return this.lastQueriedChunk;
         }
-        if(!worldObj.findingSpawnPoint && !canChunkExist(chunkX, chunkZ))
-        {
-            return blankChunk;
+        if (!this.world.findingSpawnPoint && !canChunkExist(chunkPos)) {
+            return this.blankChunk;
         }
-        int k = chunkX & CHUNK_MASK;
-        int l = chunkZ & CHUNK_MASK;
-        int i1 = k + l * CHUNK_RADIUS * 2;
-        if(!isChunkLoaded(chunkX, chunkZ))
-        {
-            if(chunks[i1] != null)
-            {
-                saveChunk(chunks[i1]);
-                chunks[i1].onUnload();
+        int cx = chunkPos.x & CHUNK_MASK;
+        int cz = chunkPos.z & CHUNK_MASK;
+        int index = cx + cz * CHUNK_RADIUS * 2;
+        if (!isChunkLoaded(chunkPos)) {
+            if (this.chunks[index] != null) {
+                this.chunks[index].onUnload();
             }
-            Chunk chunk = loadChunk(chunkX, chunkZ);
-            if(chunk == null)
-            {
-                if (chunkGenerator != null)
-                {
-                    chunk = chunkGenerator.generate(chunkX, chunkZ);
+            Chunk chunk = loadChunk(chunkPos);
+            if (chunk == null) {
+                if (this.chunkGenerator != null) {
+                    chunk = this.chunkGenerator.generate(chunkPos.x, chunkPos.z);
                     chunk.fixMissingBlocks();
+                } else {
+                    chunk = this.blankChunk;
                 }
-                else
-                {
-                    chunk = blankChunk;
-                }
-            }
-            chunks[i1] = chunk;
-            if(chunks[i1] != null)
-            {
-                chunks[i1].onLoad();
             }
-            if(!chunks[i1].isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX + 1, chunkZ))
-            {
-                populate(this, chunkX, chunkZ);
+            this.chunks[index] = chunk;
+            chunk.checkForLightGaps();
+            chunk.onLoad();
+            if (!chunk.isTerrainPopulated && isChunkLoaded(chunkPos.add(1, 1)) && isChunkLoaded(chunkPos.add(0, 1)) && isChunkLoaded(chunkPos.add(1, 0))) {
+                populate(chunkPos);
             }
-            if(isChunkLoaded(chunkX - 1, chunkZ) && !provideChunk(chunkX - 1, chunkZ).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ + 1) && isChunkLoaded(chunkX, chunkZ + 1) && isChunkLoaded(chunkX - 1, chunkZ))
-            {
-                populate(this, chunkX - 1, chunkZ);
+            if (isChunkLoaded(chunkPos.add(-1, 0)) && !provideChunk(chunkPos.add(-1, 0), true).isTerrainPopulated && isChunkLoaded(chunkPos.add(-1, 1)) && isChunkLoaded(chunkPos.add(0, 1)) && isChunkLoaded(chunkPos.add(-1, 0))) {
+                populate(chunkPos.add(-1, 0));
             }
-            if(isChunkLoaded(chunkX, chunkZ - 1) && !provideChunk(chunkX, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX + 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX + 1, chunkZ))
-            {
-                populate(this, chunkX, chunkZ - 1);
+            if (isChunkLoaded(chunkPos.add(0, -1)) && !provideChunk(chunkPos.add(0, -1), true).isTerrainPopulated && isChunkLoaded(chunkPos.add(1, -1)) && isChunkLoaded(chunkPos.add(0, -1)) && isChunkLoaded(chunkPos.add(1, 0))) {
+                populate(chunkPos.add(0, -1));
             }
-            if(isChunkLoaded(chunkX - 1, chunkZ - 1) && !provideChunk(chunkX - 1, chunkZ - 1).isTerrainPopulated && isChunkLoaded(chunkX - 1, chunkZ - 1) && isChunkLoaded(chunkX, chunkZ - 1) && isChunkLoaded(chunkX - 1, chunkZ))
-            {
-                populate(this, chunkX - 1, chunkZ - 1);
+            if (isChunkLoaded(chunkPos.add(-1, -1)) && !provideChunk(chunkPos.add(-1, -1), true).isTerrainPopulated && isChunkLoaded(chunkPos.add(-1, -1)) && isChunkLoaded(chunkPos.add(0, -1)) && isChunkLoaded(chunkPos.add(-1, 0))) {
+                populate(chunkPos.add(-1, -1));
             }
-            if (worldObj.getCurrentWeather() != null)
-            {
-                worldObj.getCurrentWeather().doChunkLoadEffect(worldObj, chunk);
+            if (this.world.getCurrentWeather() != null) {
+                this.world.getCurrentWeather().doChunkLoadEffect(this.world, chunk);
             }
         }
-        lastQueriedChunkXPos = chunkX;
-        lastQueriedChunkZPos = chunkZ;
-        lastQueriedChunk = chunks[i1];
-        return chunks[i1];
+        this.lastQueriedChunkPos = chunkPos;
+        this.lastQueriedChunk = this.chunks[index];
+        return this.chunks[index];
     }
 
-    private Chunk loadChunk(int chunkX, int chunkZ)
-    {
-        if(chunkLoader == null)
-        {
-            return blankChunk;
+    private Chunk loadChunk(@NotNull ChunkPos chunkPos) {
+        if (this.chunkLoader == null) {
+            return this.blankChunk;
         }
-        try
-        {
-            Chunk chunk = chunkLoader.loadChunk(worldObj, chunkX, chunkZ);
-            if(chunk != null)
-            {
-                chunk.lastSaveTime = worldObj.getWorldTime();
+        try {
+            Chunk chunk = this.chunkLoader.loadChunk(this.world, chunkPos.x, chunkPos.z);
+            if (chunk != null) {
+                chunk.lastSaveTime = this.world.getWorldTime();
             }
             return chunk;
+        } catch (Exception exception) {
+            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkPos.x, chunkPos.x, exception);
         }
-        catch(Exception exception)
-        {
-            LOGGER.error("Error loading chunk at X:{}, Z:{}", chunkX, chunkZ, exception);
-        }
-        return blankChunk;
-    }
-
-    private void saveChunk(Chunk chunk)
-    {
-
+        return this.blankChunk;
     }
 
     @Override
-    public void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ)
-    {
+    public void populate(@NotNull ChunkPos chunkPos) {
 
     }
 
     @Override
-    public boolean saveChunks(boolean saveImmediately, ProgressListener progressUpdate)
-    {
+    public boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener) {
         return false;
     }
 
     @Override
-    public boolean tick()
-    {
+    public boolean tick() {
         return false;
     }
 
     @Override
-    public void unloadAllChunks()
-    {
-        for (Chunk chunk : chunks) {
+    public void unloadAllChunks() {
+        for (Chunk chunk : this.chunks) {
             if (chunk != null) chunk.onUnload();
         }
-        Arrays.fill(chunks, null);
-        chunkGenerator = null;
-    	System.gc();
+        Arrays.fill(this.chunks, null);
+        this.chunkGenerator = null;
+        System.gc();
     }
 
     @Override
-    public boolean canSave()
-    {
+    public boolean canSave() {
         return false;
     }
 
     @Override
-    public String getInfoString()
-    {
-        return "ChunkCache: " + chunks.length;
-    }
-
-    public IChunkLoader getChunkLoader() {
-        return chunkLoader;
+    public @NotNull String getInfoString() {
+        return "ChunkCache: " + this.chunks.length;
     }
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
index 63a922170..7b257cfa7 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/bta/worldloader/ChunkLoader.java
@@ -12,34 +12,35 @@ import net.minecraft.core.world.chunk.ChunkLoaderLegacy;
 import net.minecraft.core.world.chunk.EmptyChunk;
 import net.minecraft.core.world.chunk.provider.IChunkProvider;
 import net.minecraft.core.world.chunk.reader.*;
+import net.minecraft.core.world.pos.ChunkPos;
 import net.minecraft.core.world.save.mcregion.RegionFileCache;
 import net.minecraft.core.world.type.WorldTypes;
-import org.useless.seedviewer.collections.ChunkLocation;
+import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.slf4j.Logger;
 
 import java.io.DataInputStream;
 import java.io.File;
 import java.io.IOException;
 import java.util.Arrays;
-import java.util.Map;
 
 public class ChunkLoader implements IChunkProvider {
     private static final Logger LOGGER = LogUtils.getLogger();
-    private final World dummyWorld;
-    private final Chunk empty;
+    private final @NotNull World dummyWorld;
+    private final @NotNull Chunk empty;
 
 
     private final File dimensionDir;
     public ChunkLoader(File worldFolder, int dimension) {
         this.dimensionDir = new File(worldFolder, "dimensions/" + dimension);
-        dummyWorld = new World();
-        dummyWorld.worldType = WorldTypes.OVERWORLD_EXTENDED;
-        dummyWorld.chunkProvider = this;
-        empty = new EmptyChunk(dummyWorld, 0, 0);
+        this.dummyWorld = new World();
+        this.dummyWorld.worldType = WorldTypes.OVERWORLD_EXTENDED;
+        this.dummyWorld.chunkProvider = this;
+        this.empty = new EmptyChunk(this.dummyWorld, 0, 0);
     }
 
-    public boolean chunkExists(ChunkLocation location) {
-        DataInputStream regionStream = RegionFileCache.getChunkInputStream(dimensionDir, location.x, location.z);
+    public boolean chunkExists(ChunkPos location) {
+        DataInputStream regionStream = RegionFileCache.getChunkInputStream(this.dimensionDir, location.x, location.z);
         CompoundTag tag;
         if(regionStream != null)
         {
@@ -57,8 +58,8 @@ public class ChunkLoader implements IChunkProvider {
         return tag.containsKey("Level");
     }
 
-    public Chunk loadChunk(ChunkLocation location) throws IOException {
-        DataInputStream regionStream = RegionFileCache.getChunkInputStream(dimensionDir, location.x, location.z);
+    public Chunk loadChunk(ChunkPos location) throws IOException {
+        DataInputStream regionStream = RegionFileCache.getChunkInputStream(this.dimensionDir, location.x, location.z);
         CompoundTag tag;
         if(regionStream != null)
         {
@@ -81,7 +82,7 @@ public class ChunkLoader implements IChunkProvider {
         ChunkReader reader = getChunkReaderByVersion(tag, version);
         int x = reader.getX();
         int z = reader.getZ();
-        Chunk chunk = new Chunk(dummyWorld, x, z);
+        Chunk chunk = new Chunk(this.dummyWorld, x, z);
         chunk.heightMap = reader.getHeightMap();
         chunk.averageBlockHeight = reader.getAverageBlockHeight();
         chunk.isTerrainPopulated = reader.getIsTerrainPopulated();
@@ -96,7 +97,7 @@ public class ChunkLoader implements IChunkProvider {
 
         if (chunk.heightMap == null) {
             chunk.heightMap = new short[256];
-            chunk.recalcHeightmap();
+            chunk.recalcHeightmapAndLightmap();
         }
 
         if (chunk.temperature == null || chunk.temperature.length == 0) {
@@ -129,36 +130,36 @@ public class ChunkLoader implements IChunkProvider {
     }
 
     @Override
-    public boolean isChunkLoaded(int chunkX, int chunkZ) {
+    public boolean isChunkLoaded(@NotNull ChunkPos chunkPos) {
         return false;
     }
 
     @Override
-    public Chunk provideChunk(int chunkX, int chunkZ) {
+    public @NotNull Chunk provideChunk(@NotNull ChunkPos chunkPos, boolean priority) {
         try {
-            return loadChunk(new ChunkLocation(chunkX, chunkZ));
+            return loadChunk(chunkPos);
         } catch (IOException e) {
-            return empty;
+            return this.empty;
         }
     }
 
     @Override
-    public Chunk prepareChunk(int chunkX, int chunkZ) {
-        return provideChunk(chunkX, chunkZ);
+    public @NotNull Chunk prepareChunk(@NotNull ChunkPos chunkPos, boolean priority) {
+        return provideChunk(chunkPos, true);
     }
 
     @Override
-    public void regenerateChunk(int chunkX, int chunkZ) {
+    public void regenerateChunk(@NotNull ChunkPos chunkPos) {
 
     }
 
     @Override
-    public void populate(IChunkProvider chunkProvider, int chunkX, int chunkZ) {
+    public void populate(@NotNull ChunkPos chunkPos) {
 
     }
 
     @Override
-    public boolean saveChunks(boolean saveImmediately, ProgressListener progressUpdate) {
+    public boolean saveChunks(boolean saveImmediately, @Nullable ProgressListener progressListener) {
         return false;
     }
 
@@ -173,7 +174,7 @@ public class ChunkLoader implements IChunkProvider {
     }
 
     @Override
-    public String getInfoString() {
+    public @NotNull String getInfoString() {
         return "";
     }
 
@@ -183,7 +184,7 @@ public class ChunkLoader implements IChunkProvider {
     }
 
     @Override
-    public void setCurrentChunkOver(int chunkX, int chunkZ) {
+    public void setCurrentChunkOver(@NotNull ChunkPos chunkPos) {
 
     }
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerChunk.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerChunk.java
index 5ba550a6d..7ed9e6440 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerChunk.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/data/ViewerChunk.java
@@ -1,15 +1,14 @@
 package org.useless.seedviewer.data;
 
 import net.minecraft.core.world.chunk.ChunkSection;
-import org.useless.seedviewer.collections.ChunkPos2D;
-import org.useless.seedviewer.collections.ChunkPos3D;
+import net.minecraft.core.world.pos.ChunkTilePos;
 
 public interface ViewerChunk {
     int CHUNK_SIZE_X = net.minecraft.core.world.chunk.Chunk.CHUNK_SIZE_X;
     int CHUNK_SIZE_Y = net.minecraft.core.world.chunk.Chunk.CHUNK_SECTIONS * ChunkSection.SECTION_SIZE_Y;
     int CHUNK_SIZE_Z = net.minecraft.core.world.chunk.Chunk.CHUNK_SIZE_Z;
-    ViewerBiome getBiome(ChunkPos3D pos);
-    int getBlockColor(ChunkPos3D pos);
-    int getHeight(ChunkPos2D pos);
-    int getWaterDepth(ChunkPos2D pos);
+    ViewerBiome getBiome(ChunkTilePos pos);
+    int getBlockColor(ChunkTilePos pos);
+    int getHeight(ChunkTilePos pos);
+    int getWaterDepth(ChunkTilePos pos);
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/gui/ChunkProvider.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/gui/ChunkProvider.java
index 4df3aba89..c5ecf6a34 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/gui/ChunkProvider.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/gui/ChunkProvider.java
@@ -1,8 +1,8 @@
 package org.useless.seedviewer.gui;
 
-import org.useless.seedviewer.collections.ChunkLocation;
+import net.minecraft.core.world.pos.ChunkPos;
 import org.useless.seedviewer.data.ViewerChunk;
 
 public interface ChunkProvider {
-    ViewerChunk getChunk(ChunkLocation location);
+    ViewerChunk getChunk(ChunkPos location);
 }
diff --git a/util/seed-viewer/src/main/java/org/useless/seedviewer/gui/ChunkView.java b/util/seed-viewer/src/main/java/org/useless/seedviewer/gui/ChunkView.java
index d4a0bd9fc..9d7ab22b3 100644
--- a/util/seed-viewer/src/main/java/org/useless/seedviewer/gui/ChunkView.java
+++ b/util/seed-viewer/src/main/java/org/useless/seedviewer/gui/ChunkView.java
@@ -1,10 +1,9 @@
 package org.useless.seedviewer.gui;
 
 import com.mojang.logging.LogUtils;
+import net.minecraft.core.world.pos.ChunkPos;
+import net.minecraft.core.world.pos.ChunkTilePos;
 import org.slf4j.Logger;
-import org.useless.seedviewer.collections.ChunkLocation;
-import org.useless.seedviewer.collections.ChunkPos2D;
-import org.useless.seedviewer.collections.ChunkPos3D;
 import org.useless.seedviewer.data.ViewerBiome;
 import org.useless.seedviewer.data.ViewerChunk;
 import org.useless.seedviewer.gui.components.Viewport;
@@ -26,71 +25,71 @@ public class ChunkView {
     private final BufferedImage waterDepthMapImage = new BufferedImage(ViewerChunk.CHUNK_SIZE_X, ViewerChunk.CHUNK_SIZE_Z, BufferedImage.TYPE_INT_ARGB);
 
     private final Rectangle bounds;
-    private final ChunkLocation location;
+    private final ChunkPos location;
     private final ChunkProvider provider;
     private final Viewport viewport;
 
     public long lastSeenTime = System.currentTimeMillis();
 
-    private Future<?> loadTask;
+    private final Future<?> loadTask;
     private Future<?> processTask = null;
 
     private boolean hasInitialized = false;
     private volatile boolean hasPostProcessed = false;
 
-    public ChunkView(Viewport viewport, ChunkLocation location, ChunkProvider provider) {
+    public ChunkView(Viewport viewport, ChunkPos location, ChunkProvider provider) {
         this.viewport = viewport;
         this.location = location;
         this.provider = provider;
         this.bounds = new Rectangle(location.x * ViewerChunk.CHUNK_SIZE_X, location.z * ViewerChunk.CHUNK_SIZE_Z, ViewerChunk.CHUNK_SIZE_X, ViewerChunk.CHUNK_SIZE_Z);
 
-        loadTask = InitializerService.submit(
+        this.loadTask = InitializerService.submit(
             () -> {
                 try {
                     ViewerChunk chunk = provider.getChunk(location);
 
                     for (int x = 0; x < ViewerChunk.CHUNK_SIZE_X; x++) {
                         for (int z = 0; z < ViewerChunk.CHUNK_SIZE_Z; z++) {
-                            ChunkPos2D pos2D = new ChunkPos2D(x, z);
+                            ChunkTilePos pos2D = new ChunkTilePos(x, 0, z);
                             int h = chunk.getHeight(pos2D) - 1;
                             if (h < 0) h = 0;
-                            heightMapImage.setRGB(x, z, h & 0xFF);
+                            this.heightMapImage.setRGB(x, z, h & 0xFF);
 
                             int wd = chunk.getWaterDepth(pos2D) & 0xFF;
-                            waterDepthMapImage.setRGB(x, z, 0xFF_00_00_00 | wd << 16 | wd << 8 | wd);
+                            this.waterDepthMapImage.setRGB(x, z, 0xFF_00_00_00 | wd << 16 | wd << 8 | wd);
 
-                            ViewerBiome b = chunk.getBiome(new ChunkPos3D(x, h, z));
-                            biomeMapImage.setRGB(x, z, b.getColor() | 0x80_00_00_00);
+                            ViewerBiome b = chunk.getBiome(new ChunkTilePos(x, h, z));
+                            this.biomeMapImage.setRGB(x, z, b.getColor() | 0x80_00_00_00);
 
-                            terrainMapImage.setRGB(x, z, chunk.getBlockColor(new ChunkPos3D(x, h, z)));
+                            this.terrainMapImage.setRGB(x, z, chunk.getBlockColor(new ChunkTilePos(x, h, z)));
                         }
                     }
                 } catch (Exception e) {
                     LOGGER.error("Error when initializing chunk {}, {}", location.x, location.z, e);
                 }
                 finally {
-                    hasInitialized = true;
+                    this.hasInitialized = true;
                 }
             }
         );
     }
 
     public boolean hasInit() {
-        return hasInitialized;
+        return this.hasInitialized;
     }
 
     public boolean hasProcessed() {
-        return hasPostProcessed;
+        return this.hasPostProcessed;
     }
 
     public void process(ChunkView posZ) {
         if (hasProcessed()) return;
         synchronized (this) {
-            processTask = PostProcessorService.submit(() -> {
+            this.processTask = PostProcessorService.submit(() -> {
                 try {
                     for (int x = 0; x < ViewerChunk.CHUNK_SIZE_X; x++) {
                         for (int z = 0; z < ViewerChunk.CHUNK_SIZE_Z; z++) {
-                            int depth = waterDepthMapImage.getRGB(x, z) & 0xFF;
+                            int depth = this.waterDepthMapImage.getRGB(x, z) & 0xFF;
 
                             int shade;
                             if (depth == 0) {
@@ -98,9 +97,9 @@ public class ChunkView {
                                 if (z == 0) {
                                     lastHeight = posZ.getHeightMapImage().getRGB(x, z + 15) & 0xFF;
                                 } else {
-                                    lastHeight = heightMapImage.getRGB(x, z - 1) & 0xFF;
+                                    lastHeight = this.heightMapImage.getRGB(x, z - 1) & 0xFF;
                                 }
-                                int height = heightMapImage.getRGB(x, z) & 0xFF;
+                                int height = this.heightMapImage.getRGB(x, z) & 0xFF;
 
                                 if (height == lastHeight) {
                                     shade = 220;
@@ -122,49 +121,49 @@ public class ChunkView {
 
 
                             if (shade != 255) {
-                                final int current = terrainMapImage.getRGB(x, z) ;
+                                final int current = this.terrainMapImage.getRGB(x, z) ;
                                 final int a = (((current >> 24) & 0xFF));
                                 final int r = (((current >> 16) & 0xFF) * shade) / 0xFF;
                                 final int g = (((current >>  8) & 0xFF) * shade) / 0xFF;
                                 final int b = (((current      ) & 0xFF) * shade) / 0xFF;
-                                terrainMapImage.setRGB(x, z, (a << 24 | r << 16 | g << 8 | b));
+                                this.terrainMapImage.setRGB(x, z, (a << 24 | r << 16 | g << 8 | b));
                             }
                         }
                     }
                 } finally {
-                    hasPostProcessed = true;
-                    viewport.repaint();
+                    this.hasPostProcessed = true;
+                    this.viewport.repaint();
                 }
             });
         }
     }
 
-    public ChunkLocation getLocation() {
-        return location;
+    public ChunkPos getLocation() {
+        return this.location;
     }
 
     public BufferedImage getBiomeMapImage() {
-        return biomeMapImage;
+        return this.biomeMapImage;
     }
 
     public BufferedImage getTerrainMapImage() {
-        return terrainMapImage;
+        return this.terrainMapImage;
     }
 
     public BufferedImage getHeightMapImage() {
-        return heightMapImage;
+        return this.heightMapImage;
     }
 
     public Rectangle getWorldBounds() {
-        return bounds;
+        return this.bounds;
     }
 
     public void kill() {
-        if (processTask != null) {
-            processTask.cancel(true);
+        if (this.processTask != null) {
+            this.processTask.cancel(true);
         }
-        if (loadTask != null) {
-            loadTask.cancel(true);
+        if (this.loadTask != null) {
+            this.loadTask.cancel(true);
         }
     }
 }
